//+-------------------------------------------------+\\
//|                                      EWB MA.mq4 |\\
//|                                                 |\\
//|                           www.theforextruth.com |\\
//+-------------------------------------------------+\\
#property copyright "Free to all my friends!"
#property link      "www.theforextruth.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red

double ma_up[], ma_down[], point;
int mode;
extern int Nb_Periods = 5;
extern string sma_ema_lwma_or_smma = "ssma";
extern int Vertical_Shift;
extern bool Draw_Line = true;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   if(sma_ema_lwma_or_smma == "sma" || sma_ema_lwma_or_smma == "SMA")
      mode = MODE_SMA;
   else if(sma_ema_lwma_or_smma == "ema" || sma_ema_lwma_or_smma == "EMA")
      mode = MODE_EMA;
   else if(sma_ema_lwma_or_smma == "lwma" || sma_ema_lwma_or_smma == "LWMA")
      mode = MODE_LWMA;
   else if(sma_ema_lwma_or_smma == "smma" || sma_ema_lwma_or_smma == "SMMA")
      mode = MODE_SMMA;
      
   if (Vertical_Shift == 0)
      point = 0;
   else if (Vertical_Shift == 1)
      point = Point;
   else
      point = Point*Vertical_Shift;

   IndicatorBuffers(2);
   SetIndexBuffer(0, ma_up);
   SetIndexBuffer(1, ma_down);
   if (Draw_Line == true) {
      SetIndexStyle(0, DRAW_LINE);
      SetIndexStyle(1, DRAW_LINE);
   }
   else {
      SetIndexStyle(0, DRAW_ARROW);
      SetIndexStyle(1, DRAW_ARROW);
      SetIndexArrow(0,110);
      SetIndexArrow(1,110);
   }
   
   ArrayInitialize(ma_up,EMPTY_VALUE);
   ArrayInitialize(ma_down,EMPTY_VALUE);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   double maNow, maPrevious;
   int counted_bars = IndicatorCounted();
   //---- check for possible errors
   if (counted_bars<0) return(-1);
   //---- last counted bar will be recounted
   if (counted_bars>0) counted_bars--;
   limit = Bars - counted_bars;
   
   for(int i=limit; i>=0; i--)
   {
      maNow = iMA(NULL,0,Nb_Periods,0,mode,PRICE_CLOSE, i)+point;
      maPrevious = iMA(NULL,0,Nb_Periods,0,mode,PRICE_CLOSE, i+1)+point;
      
      if (maNow > maPrevious) {
         if (Draw_Line == true)
            if (ma_down[i+1] != EMPTY_VALUE)
               ma_up[i+1] = ma_down[i+1];
         ma_up[i] = maNow;
      }
      else if (maNow < maPrevious) {
         if (Draw_Line == true)
            if (ma_up[i+1] != EMPTY_VALUE)
               ma_down[i+1] = ma_up[i+1];
         ma_down[i] = maNow;
      }
      else if (maNow == maPrevious) {
         if (ma_up[i+1] != EMPTY_VALUE)
            ma_up[i] = maNow;
         else
            ma_down[i] = maNow;
      }
   }
   

//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+